#include "Colors.h"

Colors::Colors(std::string input)
{
	char name[200 + 1] = { 0 };
	char rgb[6 + 1] = { 0 };
	char is_trans = ' ';

	if (input.find("\"") == std::string::npos)
	{
		sscanf_s(input.c_str(), "%i,%[^,],%[^,],%c",
			&ColorID,
			name, sizeof(name),
			rgb, sizeof(rgb),
			&is_trans, sizeof(is_trans));

		Name = name;
		RGB = rgb;
		IsTrans = is_trans == 't';
	}
	else
	{
		printf("Color contains \"\" in the name");
		abort();
	}

	// Sanity check
	if (ColorID == -2 || Name.empty() || RGB.empty() || is_trans == ' ')
	{
		printf("Color failed to load correctly, color: %s", input.c_str());
		abort();
	}
}