#include "Elements.h"

Elements::Elements(std::string input)
{
	char part_num[20 + 1] = { 0 };

	if (input.find("\"") == std::string::npos)
	{
		sscanf_s(input.c_str(), "%*[^,],%[^,],%i",
			part_num, sizeof(part_num),
			&ColorID);

		PartNum = part_num;
	}
	else
	{
		printf("InventoryPart contains \"\" in the name");
		abort();
	}

	// Sanity check
	if (PartNum.empty() || ColorID == -2)
	{
		printf("Part failed to load correctly, part: \"%s\"", input.c_str());
		abort();
	}
}

Elements::Elements(std::string part_num, int color_id) :
	PartNum(part_num),
	ColorID(color_id)
{}