#include "GottenBricks.h"

GottenBricks::GottenBricks(std::string input)
{
	char part_num[20 + 1] = { 0 };

	if (input.find("\"") == std::string::npos)
	{
		sscanf_s(input.c_str(), "%[^,],%i,%i",
			part_num, sizeof(part_num),
			&ColorID,
			&Quantity);

		PartNum = part_num;
	}
	else
	{
		printf("GottenBrick contains \"\" in the name");
		abort();
	}

	// Sanity check
	if (PartNum.empty() || ColorID == -2 || Quantity == -1)
	{
		printf("GottenBrick failed to load correctly, brick: %s", input.c_str());
		abort();
	}
}

GottenBricks::GottenBricks(Elements element, int quantity) :
	Quantity(quantity)
{
	PartNum = element.PartNum;
	ColorID = element.ColorID;
}