#include "InventoryParts.h"

InventoryParts::InventoryParts(std::string input)
{
	char part_num[20 + 1] = { 0 };
	char is_spare = ' ';
	char img_url[250] = { 0 };

	if (input.find("\"") == std::string::npos)
	{
		sscanf_s(input.c_str(), "%i,%[^,],%i,%i,%c,%[^,]",
			&InventoryID,
			part_num, sizeof(part_num),
			&ColorID,
			&Quantity,
			&is_spare, sizeof(is_spare),
			img_url, sizeof(img_url));

		PartNum = part_num;
		IsSpare = is_spare == 't';
		ImgURL = img_url;
	}
	else
	{
		printf("Inventory part contains \"\" in the name");
		abort();
	}


	// Sanity check
	bool ShouldBreak = false;
	if (!ImgURL.empty())
	{
		int Length = ImgURL.length();
		std::string str = ImgURL.substr(Length - 4);
		if (str != ".jpg" && str != ".png")
			ShouldBreak = true;
	}

	// URL can be left empty
	if (InventoryID == -1 || PartNum.empty() || ColorID == -2 || Quantity == -1 || is_spare == ' ' || ShouldBreak)
	{
		printf("Set failed to load correctly, set: %s", input.c_str());
		abort();
	}
}