#include "PartRelationships.h"

PartRelationships::PartRelationships(std::string input)
{
	char relative_type = ' ';
	char child_part_num[20 + 1] = { 0 };
	char parent_part_num[20 + 1] = { 0 };

	if (input.find("\"") == std::string::npos)
	{
		sscanf_s(input.c_str(), "%c,%[^,],%[^,]",
			&relative_type, sizeof(relative_type),
			child_part_num, sizeof(child_part_num),
			parent_part_num, sizeof(parent_part_num));

		ChildPartNum = child_part_num;
		ParentPartNum = parent_part_num;
		switch (relative_type)
		{
		case 'P': RelativeType = "Print"; break;
		case 'R': RelativeType = "Pair"; break;
		case 'B': RelativeType = "Sub_Part"; break;
		case 'M': RelativeType = "Mold"; break;
		case 'T': RelativeType = "Pattern"; break;
		case 'A': RelativeType = "Alternate"; break;
		default: printf("Relative type not regocnized, type: %c", relative_type);  abort(); break;
		}
	}
	else
	{
		printf("Part relationships contains \"\" in the name");
		abort();
	}

	// Sanity check
	if (RelativeType == "" || ChildPartNum.empty() || ParentPartNum.empty())
	{
		printf("Part relationship failed to load correctly, part: %s", input.c_str());
		abort();
	}
}