#include "Parts.h"

Parts::Parts(std::string input)
{
	char part_num[20 + 1] = { 0 };
	char name[250 + 1] = { 0 };
	char part_material[100] = { 0 };

	if (input.find("\"") == std::string::npos)
	{
		sscanf_s(input.c_str(), "%[^,],%[^,],%i,%[^,]",
			part_num, sizeof(part_num),
			name, sizeof(name),
			&PartCatID,
			part_material, sizeof(part_material));

		PartNum = part_num;
		Name = name;
		PartMaterial = part_material;
	}
	else
	{
		int BeginQM = input.find('\"') - 1;
		PartNum = input.substr(0, BeginQM);

		int EndQM = input.rfind("\",");
		Name = input.substr(BeginQM + 2, EndQM - BeginQM - 2);

		std::string str = input.substr(EndQM + 2);
		sscanf_s(str.c_str(), "%i,%[^,]",
			&PartCatID,
			part_material, sizeof(part_material));
		PartMaterial = part_material;
	}

	// Sanity check
	if (PartNum.empty() || Name.empty() || PartCatID == -1 || PartMaterial.empty())
	{
		printf("Part failed to load correctly, part: \"%s\"", input.c_str());
		abort();
	}
}