#include "Sets.h"

Sets::Sets(std::string input)
{
	char set_num[20 + 1] = { 0 };
	char name[256 + 1] = { 0 };
	char img_url[250] = { 0 };

	if (input.find("\"") == std::string::npos)
	{
		sscanf_s(input.c_str(), "%[^,],%[^,],%i,%i,%i,%[^,]",
			set_num, sizeof(set_num),
			name, sizeof(name),
			&Year,
			&ThemeID,
			&NumParts,
			img_url, sizeof(img_url));

		SetNum = set_num;
		Name = name;
		ImgURL = img_url;
	}
	else
	{
		int BeginQM = input.find('\"') - 1;
		SetNum = input.substr(0, BeginQM);

		int EndQM = input.rfind("\",");
		Name = input.substr(BeginQM + 2, EndQM - BeginQM - 2);

		std::string str = input.substr(EndQM + 2);
		sscanf_s(str.c_str(), "%i,%i,%i,%[^,]",
			&Year,
			&ThemeID,
			&NumParts,
			img_url, sizeof(img_url));
		ImgURL = img_url;
	}

	// Sanity check
	bool ShouldBreak = false;
	if (!ImgURL.empty())
	{
		int Length = ImgURL.length();
		std::string str = ImgURL.substr(Length - 4);
		if (str != ".jpg")
			ShouldBreak = true;
	}

	if (SetNum.empty() || Name.empty() || Year == -1 || ThemeID == -1 || NumParts == -1 || ImgURL.empty() || ShouldBreak)
	{
		printf("Set failed to load correctly, set: %s", input.c_str());
		abort();
	}	
}