#pragma once
#include "UIParent.h"

#include <functional>

class Button : public UIParent
{
public:
	// Methods
	Button(SDL_Surface* surface,
		glm::ivec2 screen_size,
		glm::vec2 top_left,
		glm::vec2 bottom_right,
		glm::ivec4 color,
		glm::ivec4 text_color,
		std::string text,
		std::function<void()> func);

	bool Update(glm::ivec2 MousePos, bool MouseButtonDown) override;
	void Render() override;

	// Variables
	const glm::ivec4 Color;
	const glm::ivec4 TextColor;
	const std::string Text;
	const std::function<void()> OnClick;

private:
	bool Hovered = false;
	bool Clicked = false;
	glm::ivec2 TL = glm::ivec2();
	glm::ivec2 BR = glm::ivec2();
};