#pragma once
#include "UIParent.h"

#include <functional>

class EditableTextbox : public UIParent
{
public:
	EditableTextbox(SDL_Surface* surface,
		glm::ivec2 screen_size,
		glm::vec2 top_left,
		glm::vec2 bottom_right,
		glm::ivec4 color,
		glm::ivec4 default_text_color,
		glm::ivec4 text_color,
		std::string default_text,
		std::string starting_text,
		bool should_edit,
		int max_length);

	bool Update(glm::ivec2 MousePos, bool MouseButtonDown) override;
	void Render() override;

	std::string AddCharacter(SDL_Keycode character);

	const glm::ivec4 Color;
	const glm::ivec4 DefaultTextColor;
	const glm::ivec4 TextColor;
	const std::string DefaultText;
	const int MaxLength;
	bool Editing = false;
	bool DisplayCursor = false;

private:
	bool Hovered = false;
	bool Clicked = false;
	glm::ivec2 TL = glm::ivec2();
	glm::ivec2 BR = glm::ivec2();
	std::string CurrentText;
	std::string PrevText;
	bool PrevDisplayCursor = false;
};