#include "Image.h"

Image::Image(SDL_Surface* surface,
	glm::ivec2 screen_size,
	glm::vec2 top_left,
	glm::vec2 bottom_right,
	std::string url,
	std::string path) :

	UIParent(surface, screen_size),
	URL(url)
{
	CalcTL_BR(TL, BR, top_left, bottom_right, ScreenSize);
	Surface = LoadImageFromURL(&Data, URL, path);
}

Image::~Image()
{
	SDL_FreeSurface(Surface);
	FreeImage(Data);
}

bool Image::Update(glm::ivec2, bool)
{
	return false;
}

void Image::Render()
{
	if (Surface != nullptr)
	{
		SDL_Rect SourceRect = SDL_Rect();
		SourceRect.x = 0;
		SourceRect.y = 0;
		SourceRect.w = Surface->w;
		SourceRect.h = Surface->h;

		SDL_Rect DestRect = SDL_Rect();
		DestRect.x = TL.x;
		DestRect.y = TL.y;
		DestRect.w = BR.x - TL.x;
		DestRect.h = BR.y - TL.y;

		SDL_BlitScaled(Surface, &SourceRect, ManagerSurface, &DestRect);
	}
}