#pragma once
#include "UIParent.h"
#include "../FileIO/GottenBricks.h"
#include "../FileIO/Sets.h"
#include "../FileIO/InventoryParts.h"

#include <vector>
#include <functional>

class Tile : public UIParent
{
public:
	// GottenBricks tile
	Tile(SDL_Surface* surface,
		glm::ivec2 screen_size,
		glm::vec2 top_left,
		glm::vec2 bottom_right,
		glm::ivec4 color,
		glm::ivec4 text_color,
		GottenBricks* item,
		bool show_quantity,
		std::vector<InventoryParts>* inventory_parts,
		std::function<void(GottenBricks* item)> func);

	// Sets tile
	Tile(SDL_Surface* surface,
		glm::ivec2 screen_size,
		glm::vec2 top_left,
		glm::vec2 bottom_right,
		glm::ivec4 color,
		glm::ivec4 text_color,
		Sets* item,
		bool show_quantity,
		std::function<void(Sets* item)> func);

	~Tile() override;

	// Methods
	void Init(glm::vec2 top_left, glm::vec2 bottom_right, std::vector<InventoryParts>* inventory_parts);
	bool Update(glm::ivec2 MousePos, bool MouseButtonDown) override;
	void Render() override;

	// Variables
	const glm::ivec4 Color;
	const glm::ivec4 TextColor;
	const bool UsingBricks;

	// GottenBricks variables
	GottenBricks* GB_Item = nullptr;
	std::function<void(GottenBricks* item)> GB_OnClick = std::function<void(GottenBricks* item)>(nullptr);

	// Sets variables
	Sets* S_Item = nullptr;
	std::function<void(Sets* item)> S_OnClick = std::function<void(Sets* item)>(nullptr);

private:
	bool Hovered = false;
	bool Clicked = false;
	glm::ivec2 TL = glm::ivec2();
	glm::ivec2 BR = glm::ivec2();
	const bool ShowQuantity;

	// Image variables
	SDL_Surface* Surface = nullptr;
	void* Data = nullptr;
};