#pragma once
#pragma comment(lib, "Urlmon.lib")
#include <urlmon.h>
#include <SDL.h>
#include <string>
#include <glm/vec2.hpp>
#include <glm/vec4.hpp>
#include "../FileIO/GottenBricks.h"
#include "../FileIO/Sets.h"

class UIParent
{
public:
	UIParent(SDL_Surface* surface,
		glm::ivec2 screen_size);
	virtual ~UIParent() {}
	
	virtual bool Update(glm::ivec2 MousePos, bool MouseButtonDown) = 0;
	virtual void Render() = 0;

protected:
	void DrawString(std::string str, glm::ivec2 pos, glm::ivec4 color, bool centered, float size);
	void CalcTL_BR(glm::ivec2& TL, glm::ivec2& BR, glm::vec2 top_left, glm::vec2 bottom_right, glm::ivec2 screen_size);
	void FreeImage(void* data);
	SDL_Surface* LoadImageFromDisk(void** data, std::string path, bool silence);
	SDL_Surface* LoadImageFromURL(void** data,
		std::string URL,
		std::string Path = "",
		GottenBricks* GB_Item = nullptr,
		Sets* S_Item = nullptr);

	SDL_Surface* ManagerSurface;
	const glm::ivec2 ScreenSize;

private:
	void DrawChar(const char character, glm::ivec2 pos, glm::ivec4 color, float size);
};